diff --git a/app/fin/service/ecs_device_service.go b/app/fin/service/ecs_device_service.go
index 73c54726419dc82e4a3591bdcc209421b7506659..2f37f319ae681ee1caded4dfb1615f41509b306d 100644
--- a/app/fin/service/ecs_device_service.go
+++ b/app/fin/service/ecs_device_service.go
@@ -17,7 +17,7 @@ import (
 )
 
 type IFinEcsDeviceService interface {
-	ListAll(ids []uint, chemeId uint, deviceIds []uint) (res []finModel.FinEcsDevice, e error)
+	ListAll(ids []uint, schemeId uint, deviceIds []uint) (res []finModel.FinEcsDevice, e error)
 	List(page request.PageReq, listReq finReq.FinEcsDeviceListReq, auth *request.AuthReq) (res response.PageResp, e error)
 	Detail(id uint, auth *request.AuthReq) (res finReq.FinEcsDeviceResp, e error)
 	Add(addReq finReq.FinEcsDeviceAddReq, auth *request.AuthReq) (e error)
@@ -50,7 +50,7 @@ type FinEcsDeviceService struct {
 // ListAll [财务]-计费方案设备绑定列表
 func (srv FinEcsDeviceService) ListAll(ids []uint, schemeId uint, deviceIds []uint) (res []finModel.FinEcsDevice, e error) {
 	// 查询
-	model := srv.db.Model(&finModel.FinEcsDevice{})
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinEcsDevice{}), nil)
 	if schemeId != 0 {
 		model.Where("scheme_id = ?", schemeId)
 	}
@@ -76,7 +76,7 @@ func (srv FinEcsDeviceService) List(page request.PageReq, listReq finReq.FinEcsD
 	limit := page.PageSize
 	offset := page.PageSize * (page.PageNo - 1)
 	// 查询
-	model := srv.db.Model(&finModel.FinEcsDevice{})
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinEcsDevice{}), auth)
 
 	// 总数
 	var count int64
@@ -399,6 +399,9 @@ func (srv FinEcsDeviceService) ListAllBindDevice(listReq finReq.FinEcsDeviceList
 	if len(listReq.AreaName) > 0 {
 		model = model.Where("area_name like '%?%'", listReq.AreaName)
 	}
+	if len(listReq.HouseType) > 0 {
+		model = model.Where("house_type like ?", listReq.HouseType)
+	}
 	if len(listReq.MeterType) > 0 {
 		meterType := listReq.MeterType
 		if listReq.MeterType == "em" {
@@ -442,7 +445,7 @@ func (srv FinEcsDeviceService) ListUnBindDevice(page request.PageReq, listReq fi
 select device.id as device_id, device.name as device_name, device.flag as meter_type, device.address, instrument.area_id as house_id  from {deviceInstrument} device left join {areaInstrument} instrument on device.id = instrument.instrument_id where device.is_deleted = 0
 ) device
 join(
-select area.id as house_id, area.name as house_name, hierarchy.id as area_id, hierarchy.name as area_name from {portfolioArea} area left join {portfolioHierarchy} hierarchy on area.hierarchy_id = "hierarchy"."id" where area.is_deleted = 0 and hierarchy.is_deleted = 0 and area.type = 'house'
+select area.id as house_id, area.name as house_name, hierarchy.id as area_id, hierarchy.name as area_name, type as house_type from {portfolioArea} area left join {portfolioHierarchy} hierarchy on area.hierarchy_id = "hierarchy"."id" where area.is_deleted = 0 and hierarchy.is_deleted = 0 and area.type = 'house'
 ) house
 on house.house_id = device.house_id
 where device_id not in(
@@ -517,7 +520,7 @@ select device_id from {schemeDevice} scheme where is_deleted = 0) {cond}`
 		return
 	}
 
-	sql = strings.Replace(rawSql, "{columns}", "device.*, house.house_name, house.area_id, house.area_name", -1)
+	sql = strings.Replace(rawSql, "{columns}", "device.*, house.house_name, house.area_id, house.area_name, house.house_type", -1)
 	// 数据
 	var objs []finReq.FinEcsDeviceResp
 	err = srv.db.Raw(sql).Limit(limit).Offset(offset).Order("id desc").Find(&objs).Error
@@ -554,11 +557,14 @@ func (srv FinEcsDeviceService) ListSchemeDevice(listReq finReq.FinEcsDeviceListR
 		model = model.Where("house_id=?", listReq.HouseId)
 	}
 	if len(listReq.HouseName) > 0 {
-		model = model.Where("house like '%?%'", listReq.HouseName)
+		model = model.Where("house_name like '%?%'", listReq.HouseName)
 	}
 	if len(listReq.HouseIds) > 0 {
 		model = model.Where("house_id in (?)", listReq.HouseIds)
 	}
+	if len(listReq.HouseType) > 0 {
+		model = model.Where("house_type like ?", listReq.HouseType)
+	}
 	if listReq.AreaId != 0 {
 		model = model.Where("area_id=?", listReq.AreaId)
 	}
diff --git a/app/fin/service/electric_service.go b/app/fin/service/electric_service.go
index 8a08d062ac50e829ccc2c7d02e8301fad8807bf0..f69ea8740de5b7e60abd85ff8c44f7d75609cb1d 100644
--- a/app/fin/service/electric_service.go
+++ b/app/fin/service/electric_service.go
@@ -24,6 +24,7 @@ type IFinSharedElectricService interface {
 	SaveBatch(commonAreaId uint, savetReqs []finReq.FinSharedElectricSaveReq, auth *request.AuthReq) (e error)
 	Del(id uint, auth *request.AuthReq) (e error)
 	InfoAreaScheme(commonAreaId uint, auth *request.AuthReq) (res interface{}, e error)
+	ListAllByExecType(execType string) (res []finModel.FinSharedElectric, e error)
 }
 
 // NewFinSharedElectricService 初始化
@@ -499,7 +500,7 @@ func (srv FinSharedElectricService) ListAllByType(listReq finReq.FinSharedScheme
 	// 查询
 	model := query.AuthQuery(srv.db.Model(&cond), auth)
 	// 数据
-	var objs []finModel.FinSharedAtt
+	var objs []finModel.FinSharedElectric
 	err := model.Order("scheme_type asc").Find(&objs).Error
 	if e = response.CheckErr(err, "List Find err"); e != nil {
 		return
@@ -711,3 +712,22 @@ func (srv FinSharedElectricService) ListAll(listReq finReq.FinSharedListReq) (re
 	}
 	return resps, nil
 }
+
+// List [财务]-公摊计费方案-执行类型方案列表
+func (srv FinSharedElectricService) ListAllByExecType(execType string) (res []finModel.FinSharedElectric, e error) {
+	var cond finModel.FinSharedElectric
+	cond.ExecType = execType
+	// 查询
+	model := query.AuthQuery(srv.db.Model(&cond), nil)
+	// 数据
+	var objs []finModel.FinSharedElectric
+	err := model.Order("id asc").Find(&objs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+	var areaIds []uint
+	for _, item := range objs {
+		areaIds = append(areaIds, item.CommonAreaId)
+	}
+	return objs, nil
+}
diff --git a/app/fin/service/purse_flow_service.go b/app/fin/service/purse_flow_service.go
index 64b28c44968dd73c018e9aebfb4e71e7ee80014b..0d0107c76370ce032a239f461ab4ce2d7573b6e5 100644
--- a/app/fin/service/purse_flow_service.go
+++ b/app/fin/service/purse_flow_service.go
@@ -24,6 +24,7 @@ type IFinPurseFlowService interface {
 	Edit(editReq finReq.FinPurseFlowEditReq, auth *request.AuthReq) (e error)
 	Del(id uint, auth *request.AuthReq) (e error)
 	ListBill(page request.PageReq, listReq finReq.FinPurseFlowInvoiceListReq, auth *request.AuthReq) (res response.PageResp, e error)
+	ListFlowByBillId(billId uint, flowType string, feeType string) (resps []finModel.FinPurseFlow, e error)
 	Generated(listReq finReq.FinInvoiceGenralReq, auth *request.AuthReq) (res []finReq.FinInvoiceResp, flowIds []uint, e error)
 	UpdateReceiptState(flowIds []uint, auth *request.AuthReq) (e error)
 }
@@ -341,7 +342,7 @@ func (srv finPurseFlowService) ListBills(flowIds []uint) (resps []finReq.FinPurs
 		}
 		item.FeeType = constants.GetFeeName(obj.FeeType)
 		item.FlowType = constants.GetFlowType(obj.FlowType)
-		if obj.FlowType == "bill" {
+		if obj.FlowType == constants.FlowTypeEnum.Bill || obj.FlowType == constants.FlowTypeEnum.Shared {
 			var bill finModel.FinBill
 			err := srv.db.Where("id = ?", obj.BillId).Where("is_deleted = 0").Limit(1).First(&bill).Error
 			if err != nil && bill.Id > 0 {
@@ -381,6 +382,25 @@ func (srv finPurseFlowService) ListBills(flowIds []uint) (resps []finReq.FinPurs
 	return resps, nil
 }
 
+// List [财务]-钱包资金流水列表
+func (srv finPurseFlowService) ListFlowByBillId(billId uint, flowType string, feeType string) (resps []finModel.FinPurseFlow, e error) {
+	// 查询
+	model := srv.db.Model(&finModel.FinPurseFlow{})
+	model = model.Where("billId = ? and flowType = ?", billId, flowType)
+	if len(feeType) > 0 {
+		model = model.Where("feeType = ?", feeType)
+	}
+
+	// 数据
+	var objs []finModel.FinPurseFlow
+	err := model.Order("id desc").Find(&objs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+
+	return objs, nil
+}
+
 // List [财务]-发票列表生成
 func (srv finPurseFlowService) Generated(listReq finReq.FinInvoiceGenralReq, auth *request.AuthReq) (res []finReq.FinInvoiceResp, flowIds []uint, e error) {
 	book, err := srv.srvBook.Detail(listReq.BookId, nil)
diff --git a/app/fin/service/purse_service.go b/app/fin/service/purse_service.go
index 57badcdc6ebd82bfe496b9226b9a411e1b8cea63..7106ae39b7a3c51249097dae1969136eb46c07dc 100644
--- a/app/fin/service/purse_service.go
+++ b/app/fin/service/purse_service.go
@@ -27,6 +27,7 @@ type IFinPurseService interface {
 	Stats(listReq finReq.FinPurseListReq, auth *request.AuthReq) (res finReq.FinPurseStatsResp, e error)
 	FeeChange(addReq finReq.FinPurseFeeEditReq, auth *request.AuthReq) (e error)
 	GetHouseAmont(houseId uint, ecsType string) (amount float64, e error)
+	GetPurseIds(listReq finReq.FinPurseIdsReq) (purseIds []uint, e error)
 }
 
 // NewFinPurseService 初始化
@@ -438,6 +439,11 @@ func (srv finPurseService) FeeChange(addReq finReq.FinPurseFeeEditReq, auth *req
 		TenantId:      obj.TenantId,
 		PaymentTime:   addReq.PaymentTime,
 		PaymentMethod: addReq.PaymentMethod,
+		Payee:         auth.Username,
+	}
+	nilTime := time.Time{}
+	if flow.PaymentTime == nilTime {
+		flow.PaymentTime = now
 	}
 	saveObj.CreateBy = auth.Username
 	saveObj.CreateTime = now
@@ -480,3 +486,35 @@ func (srv finPurseService) GetHouseAmont(houseId uint, ecsType string) (amount f
 	}
 	return
 }
+
+// 获取指定类型费用
+func (srv finPurseService) GetPurseIds(listReq finReq.FinPurseIdsReq) (purseIds []uint, e error) {
+	// 查询
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinPurse{}), nil)
+	if listReq.AreaId != 0 {
+		model = model.Where("area_id = ?", listReq.AreaId)
+	}
+	if len(listReq.AreaName) > 0 {
+		model = model.Where("area_name like ?", "%"+listReq.AreaName+"%")
+	}
+	if listReq.HouseId != 0 {
+		model = model.Where("house_id = ?", listReq.HouseId)
+	}
+	if listReq.HouseName != "" {
+		model = model.Where("house_name like ?", "%"+listReq.HouseName+"%")
+	}
+	if listReq.OwnerId != 0 {
+		model = model.Where("owner_id = ?", listReq.OwnerId)
+	}
+	if listReq.OwnerName != "" {
+		model = model.Where("owner_name like ?", "%"+listReq.OwnerName+"%")
+	}
+	if listReq.EcsType != "" {
+		model = model.Where("ecs_type = ?", listReq.EcsType)
+	}
+	err := model.Select("id").Find(&purseIds).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+	return
+}
diff --git a/app/fin/service/report_service.go b/app/fin/service/report_service.go
index ff498ebd4817050cb44165d269e2b531364716b8..6ff912ac7b94fcdfbf9d42ed8c990bb35b9e4aed 100644
--- a/app/fin/service/report_service.go
+++ b/app/fin/service/report_service.go
@@ -1,27 +1,633 @@
 package service
 
 import (
+	"energy-server-mgo/app/admin/schemas/query"
 	request "energy-server-mgo/app/admin/schemas/req"
+	"energy-server-mgo/app/fin/constants"
+	finModel "energy-server-mgo/app/fin/model"
 	finReq "energy-server-mgo/app/fin/schemas"
+	"energy-server-mgo/core/response"
+	"time"
 
 	"gorm.io/gorm"
 )
 
 type IFinReportService interface {
-	List(listReq finReq.FinCommonDeviceReq, auth *request.AuthReq) (res []finReq.FinCommonDeviceResp, e error)
+	InfoStatsEcs(listReq finReq.FinReportEcsReq, auth *request.AuthReq) (res finReq.FinReportEcsStasRes, e error)
+	ListEcs(page request.PageReq, listReq finReq.FinReportEcsReq, auth *request.AuthReq) (res response.PageResp, e error)
+	InfoStatsPurse(listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res finReq.FinReportPurseStasRes, e error)
+	ListPurseFlow(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error)
+	ListPurseDeduct(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error)
+	ListPurseUsage(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error)
+	ListStepBill(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error)
+	ListPurseShared(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error)
 }
 
 // NewFinReportService 初始化
-func NewFinReportService(db *gorm.DB) IFinReportService {
-	return &finReportService{db: db}
+func NewFinReportService(db *gorm.DB, srvBill IFinBillService, srvPurse IFinPurseService, srvPurseFlow IFinPurseFlowService, srvCommon IFinCommonService) IFinReportService {
+	return &finReportService{db: db, srvBill: srvBill, srvPurse: srvPurse, srvCommon: srvCommon, srvPurseFlow: srvPurseFlow}
 }
 
 // finReportService 通用服务实现类
 type finReportService struct {
-	db *gorm.DB
+	db           *gorm.DB
+	srvBill      IFinBillService
+	srvPurse     IFinPurseService
+	srvPurseFlow IFinPurseFlowService
+	srvCommon    IFinCommonService
 }
 
-// List
-func (srv finReportService) List(listReq finReq.FinCommonDeviceReq, auth *request.AuthReq) (res []finReq.FinCommonDeviceResp, e error) {
-	return []finReq.FinCommonDeviceResp{}, nil
+// InfoStatsEcs 能耗账单
+func (srv finReportService) InfoStatsEcs(listReq finReq.FinReportEcsReq, auth *request.AuthReq) (res finReq.FinReportEcsStasRes, e error) {
+	// 查询
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinBill{}), auth)
+	if listReq.AreaId != 0 {
+		model = model.Where("area_id = ?", listReq.AreaId)
+	}
+	if len(listReq.AreaName) > 0 {
+		model = model.Where("area_name like ?", "%"+listReq.AreaName+"%")
+	}
+	if listReq.HouseId != 0 {
+		model = model.Where("house_id = ?", listReq.HouseId)
+	}
+	if listReq.HouseName != "" {
+		model = model.Where("house_name like ?", "%"+listReq.HouseName+"%")
+	}
+	if listReq.OwnerId != 0 {
+		model = model.Where("owner_id = ?", listReq.OwnerId)
+	}
+	if listReq.OwnerName != "" {
+		model = model.Where("owner_name like ?", "%"+listReq.OwnerName+"%")
+	}
+	if listReq.OnAccount != "" {
+		model = model.Where("on_account = ?", listReq.OnAccount)
+	}
+	// 数据
+	var objs []finReq.FinReportEcsStasRes
+	err := model.Select("sum(bill_amount) as bill_amount, sum(unpaid_amount) as unpaid_amount, sum(paid_amount) as paid_amount, sum(late_amount) as late_amount, sum(reduction_amount) as reduction_amount, sum(usage_total) as usage_total").Find(&objs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+	for _, obj := range objs {
+		res.BillAmount += obj.BillAmount
+		res.LateAmount += obj.LateAmount
+		res.PaidAmount += obj.PaidAmount
+		res.UnpaidAmount += obj.UnpaidAmount
+		res.ReductionAmount += obj.ReductionAmount
+		res.UsageTotal += obj.UsageTotal
+	}
+
+	// 数据
+	purseIds, _ := srv.srvPurse.GetPurseIds(listReq.FinPurseIdsReq)
+	if len(purseIds) <= 0 {
+		return
+	}
+	// 查询
+	sql := query.NewAuthQuery(srv.db.Model(&finModel.FinPurseFlow{}), auth)
+	sql = sql.Where("purse_id in (?)", purseIds)
+	sql = sql.Where("fee_type = 'refund'")
+	var tmpObjs []finReq.FinReportEcsStasRes
+	err = sql.Select("sum(operate_amount) as refund_amount").Find(&tmpObjs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+	for _, obj := range tmpObjs {
+		res.RefundAmount += obj.RefundAmount
+	}
+
+	return
+}
+
+// ListEcs 能耗账单列表(含用能费用报表)
+func (srv finReportService) ListEcs(page request.PageReq, listReq finReq.FinReportEcsReq, auth *request.AuthReq) (res response.PageResp, e error) {
+	// 分页信息
+	limit := page.PageSize
+	offset := page.PageSize * (page.PageNo - 1)
+	// 查询
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinBill{}), auth)
+	if listReq.AreaId != 0 {
+		model = model.Where("area_id = ?", listReq.AreaId)
+	}
+	if len(listReq.AreaName) > 0 {
+		model = model.Where("area_name like ?", "%"+listReq.AreaName+"%")
+	}
+	if listReq.HouseId != 0 {
+		model = model.Where("house_id = ?", listReq.HouseId)
+	}
+	if listReq.HouseName != "" {
+		model = model.Where("house_name like ?", "%"+listReq.HouseName+"%")
+	}
+	if listReq.OwnerId != 0 {
+		model = model.Where("owner_id = ?", listReq.OwnerId)
+	}
+	if listReq.OwnerName != "" {
+		model = model.Where("owner_name like ?", "%"+listReq.OwnerName+"%")
+	}
+	if listReq.OnAccount != "" {
+		model = model.Where("on_account = ?", listReq.OnAccount)
+	}
+	// 总数
+	var count int64
+	err := model.Count(&count).Error
+	if e = response.CheckErr(err, "List Count err"); e != nil {
+		return
+	}
+	// 数据
+	var objs []finModel.FinBill
+	err = model.Limit(limit).Offset(offset).Order("id desc").Find(&objs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+
+	nilTime := time.Time{}
+	resps := []finReq.FinReportEcsListRes{}
+	for _, obj := range objs {
+		var item finReq.FinReportEcsListRes
+		response.Copy(&item, obj)
+		item.MeterType = constants.GetEcsTypeName(item.FeeName)
+		item.FeeNameTip = constants.GetFeeName(item.FeeName) + "-" + obj.Address
+		item.FeeRange = obj.StartDate.Format("2006-01-02") + " 至 " + obj.EndDate.Format("2006-01-02")
+		if obj.StartDate != nilTime {
+			item.StartDate = obj.StartDate.Format("2006-01-02")
+		}
+		if obj.EndDate != nilTime {
+			item.EndDate = obj.EndDate.Format("2006-01-02")
+		}
+		if obj.FinTime != nilTime {
+			item.FinTime = obj.FinTime.Format("2006-01-02 15:04:05")
+		}
+		flows, err := srv.srvPurseFlow.ListFlowByBillId(obj.Id, constants.FlowTypeEnum.Bill, "deduct")
+		if err == nil && len(flows) > 0 {
+			flow := flows[0]
+			item.PaymentMethod = constants.GetPaymentMethod(flow.PaymentMethod)
+			if flow.PaymentTime != nilTime {
+				item.PaymentTime = flow.PaymentTime.Format("2006-01-02 15:04:05")
+			}
+			item.Payee = flow.Payee
+			item.Payer = flow.Payer
+		}
+		resps = append(resps, item)
+	}
+	return response.PageResp{
+		PageNo:   page.PageNo,
+		PageSize: page.PageSize,
+		Count:    count,
+		Lists:    resps,
+	}, nil
+}
+
+// InfoStatsPurse 钱包统计
+func (srv finReportService) InfoStatsPurse(listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res finReq.FinReportPurseStasRes, e error) {
+	// 数据
+	purseIds, _ := srv.srvPurse.GetPurseIds(listReq.FinPurseIdsReq)
+	if len(purseIds) <= 0 {
+		return
+	}
+
+	// 查询
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinPurseFlow{}), auth)
+	if listReq.AreaId != 0 {
+		model = model.Where("area_id = ?", listReq.AreaId)
+	}
+	if len(listReq.AreaName) > 0 {
+		model = model.Where("area_name like %?%", listReq.AreaName)
+	}
+	if listReq.HouseId != 0 {
+		model = model.Where("house_id = ?", listReq.HouseId)
+	}
+	if listReq.HouseName != "" {
+		model = model.Where("house_name like %?%", listReq.HouseName)
+	}
+	if listReq.OwnerId != 0 {
+		model = model.Where("owner_id = ?", listReq.OwnerId)
+	}
+	if listReq.OwnerName != "" {
+		model = model.Where("owner_name like %?%", listReq.OwnerName)
+	}
+	if listReq.EcsType != "" {
+		model = model.Where("owner_name = ?", listReq.EcsType)
+	}
+	nilTime := time.Time{}
+	if listReq.StartDay != nilTime {
+		model = model.Where("payment_time >= ?", listReq.StartDay)
+	}
+	if listReq.EndDay != nilTime {
+		model = model.Where("payment_time <= ?", listReq.EndDay)
+	}
+	model = model.Where("purse_id in(?)", purseIds)
+
+	var statsList []finReq.FinReportPurseStasRes
+	// 数据
+	err := model.Select("ecs_type, fee_type, sum(operate_amount) as total_amount").Group("ecs_type, fee_type").Find(&statsList).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+	for _, stats := range statsList {
+		res.Total.TotalAmount += stats.TotalAmount
+		if stats.FeeType == "pay" {
+			res.Total.PaidAmount += stats.TotalAmount
+		}
+		if stats.EcsType == "electric" {
+			res.Electric.TotalAmount += stats.TotalAmount
+			if stats.FeeType == "pay" {
+				res.Electric.PaidAmount += stats.TotalAmount
+			}
+			continue
+		}
+		if stats.EcsType == "water" {
+			res.Water.TotalAmount += stats.TotalAmount
+			if stats.FeeType == "pay" {
+				res.Water.PaidAmount += stats.TotalAmount
+			}
+			continue
+		}
+		if stats.EcsType == "gas" {
+			res.Gas.TotalAmount += stats.TotalAmount
+			if stats.FeeType == "pay" {
+				res.Gas.PaidAmount += stats.TotalAmount
+			}
+		}
+	}
+	return
+}
+
+// ListPurseFlow 钱包流水报表
+func (srv finReportService) ListPurseFlow(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error) {
+	// 分页信息
+	limit := page.PageSize
+	offset := page.PageSize * (page.PageNo - 1)
+	// 查询
+	// 数据
+	purseIds, _ := srv.srvPurse.GetPurseIds(listReq.FinPurseIdsReq)
+	if len(purseIds) <= 0 {
+		return
+	}
+
+	// 查询
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinPurseFlow{}), auth)
+	if listReq.AreaId != 0 {
+		model = model.Where("area_id = ?", listReq.AreaId)
+	}
+	if len(listReq.AreaName) > 0 {
+		model = model.Where("area_name like %?%", listReq.AreaName)
+	}
+	if listReq.HouseId != 0 {
+		model = model.Where("house_id = ?", listReq.HouseId)
+	}
+	if listReq.HouseName != "" {
+		model = model.Where("house_name like %?%", listReq.HouseName)
+	}
+	if listReq.OwnerId != 0 {
+		model = model.Where("owner_id = ?", listReq.OwnerId)
+	}
+	if listReq.OwnerName != "" {
+		model = model.Where("owner_name like %?%", listReq.OwnerName)
+	}
+	if listReq.EcsType != "" {
+		model = model.Where("owner_name = ?", listReq.EcsType)
+	}
+	nilTime := time.Time{}
+	if listReq.StartDay != nilTime {
+		model = model.Where("payment_time >= ?", listReq.StartDay)
+	}
+	if listReq.EndDay != nilTime {
+		model = model.Where("payment_time <= ?", listReq.EndDay)
+	}
+	if len(listReq.FeeType) > 0 {
+		model = model.Where("fee_type = ?", listReq.FeeType)
+	}
+	model = model.Where("flow_type = ?", constants.FlowTypeEnum.Purse)
+	model = model.Where("purse_id in(?)", purseIds)
+
+	// 总数
+	var count int64
+	err := model.Count(&count).Error
+	if e = response.CheckErr(err, "List Count err"); e != nil {
+		return
+	}
+	// 数据
+	var objs []finModel.FinPurseFlow
+	err = model.Limit(limit).Offset(offset).Order("id desc").Find(&objs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+
+	resps := []finReq.FinReportPurseFlowListRes{}
+	for _, obj := range objs {
+		var item finReq.FinReportPurseFlowListRes
+		response.Copy(&item, obj)
+		if len(item.AreaName) <= 0 {
+			purse, err := srv.srvPurse.Detail(item.PurseId, auth)
+			if err == nil && purse.Id > 0 {
+				item.AreaName = purse.AreaName
+				item.HouseName = purse.HouseName
+			}
+		}
+		item.EcsType = constants.GetEcsTypeName(item.EcsType)
+		item.PaymentMethod = constants.GetPaymentMethod(item.PaymentMethod)
+		item.PaymentTime = obj.PaymentTime.Format("2006-01-02 15:04:05")
+		resps = append(resps, item)
+	}
+	return response.PageResp{
+		PageNo:   page.PageNo,
+		PageSize: page.PageSize,
+		Count:    count,
+		Lists:    resps,
+	}, nil
+}
+
+// ListPurseDeduct 扣费报表
+func (srv finReportService) ListPurseDeduct(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error) {
+	// 分页信息
+	limit := page.PageSize
+	offset := page.PageSize * (page.PageNo - 1)
+	// 查询
+	// 数据
+	purseIds, _ := srv.srvPurse.GetPurseIds(listReq.FinPurseIdsReq)
+	if len(purseIds) <= 0 {
+		return
+	}
+
+	// 查询
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinPurseFlow{}), auth)
+	if listReq.AreaId != 0 {
+		model = model.Where("area_id = ?", listReq.AreaId)
+	}
+	if len(listReq.AreaName) > 0 {
+		model = model.Where("area_name like %?%", listReq.AreaName)
+	}
+	if listReq.HouseId != 0 {
+		model = model.Where("house_id = ?", listReq.HouseId)
+	}
+	if listReq.HouseName != "" {
+		model = model.Where("house_name like %?%", listReq.HouseName)
+	}
+	if listReq.OwnerId != 0 {
+		model = model.Where("owner_id = ?", listReq.OwnerId)
+	}
+	if listReq.OwnerName != "" {
+		model = model.Where("owner_name like %?%", listReq.OwnerName)
+	}
+	if listReq.EcsType != "" {
+		model = model.Where("owner_name = ?", listReq.EcsType)
+	}
+	nilTime := time.Time{}
+	if listReq.StartDay != nilTime {
+		model = model.Where("payment_time >= ?", listReq.StartDay)
+	}
+	if listReq.EndDay != nilTime {
+		model = model.Where("payment_time <= ?", listReq.EndDay)
+	}
+	model = model.Where("fee_type = 'deduct'")
+	model = model.Where("purse_id in(?)", purseIds)
+
+	// 总数
+	var count int64
+	err := model.Count(&count).Error
+	if e = response.CheckErr(err, "List Count err"); e != nil {
+		return
+	}
+	// 数据
+	var objs []finModel.FinPurseFlow
+	err = model.Limit(limit).Offset(offset).Order("id desc").Find(&objs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+
+	resps := []finReq.FinReportPurseDeductListRes{}
+	response.Copy(&resps, objs)
+	for _, obj := range objs {
+		var item finReq.FinReportPurseDeductListRes
+		response.Copy(&item, obj)
+		item.EcsType = constants.GetEcsTypeName(item.EcsType)
+		item.PaymentMethod = constants.GetPaymentMethod(item.PaymentMethod)
+		item.PaymentTime = obj.PaymentTime.Format("2006-01-02 15:04:05")
+		ownerMap, _ := srv.srvCommon.ListHouseOwnerMap(finReq.FinCommonOwnerHouseReq{HouseId: item.HouseId}, auth)
+		var ownerNames string
+		if owners, find := ownerMap[item.HouseId]; find {
+			for idx, owner := range owners {
+				if idx == 0 {
+					ownerNames = owner.OwnerName
+				} else {
+					ownerNames = ownerNames + "," + owner.OwnerName
+				}
+			}
+		}
+		item.OwnerName = ownerNames
+		if item.BillId > 0 {
+			bill, err := srv.srvBill.Detail(item.BillId, auth)
+			if err == nil && bill.Id > 0 {
+				item.UsageStart = bill.UsageStart
+				item.UsageEnd = bill.UsageEnd
+				item.UsageTotal = bill.UsageTotal
+			}
+		}
+		resps = append(resps, item)
+	}
+	return response.PageResp{
+		PageNo:   page.PageNo,
+		PageSize: page.PageSize,
+		Count:    count,
+		Lists:    resps,
+	}, nil
+}
+
+// ListPurseUsage 用能费用报表
+func (srv finReportService) ListPurseUsage(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error) {
+	// 分页信息
+	limit := page.PageSize
+	offset := page.PageSize * (page.PageNo - 1)
+	// 查询
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinPurseFlow{}), auth)
+	if listReq.AreaId != 0 {
+		model = model.Where("area_id = ?", listReq.AreaId)
+	}
+	if len(listReq.AreaName) > 0 {
+		model = model.Where("area_name like %?%", listReq.AreaName)
+	}
+	if listReq.HouseId != 0 {
+		model = model.Where("house_id = ?", listReq.HouseId)
+	}
+	if listReq.HouseName != "" {
+		model = model.Where("house_name like %?%", listReq.HouseName)
+	}
+	nilTime := time.Time{}
+	if listReq.StartDay != nilTime {
+		model = model.Where("fin_time >= ?", listReq.StartDay)
+	}
+	if listReq.EndDay != nilTime {
+		model = model.Where("fin_time <= ?", listReq.EndDay)
+	}
+	model = model.Where("bill_type = '0'")
+
+	// 总数
+	var count int64
+	err := model.Count(&count).Error
+	if e = response.CheckErr(err, "List Count err"); e != nil {
+		return
+	}
+	// 数据
+	var objs []finModel.FinBill
+	err = model.Limit(limit).Offset(offset).Order("id desc").Find(&objs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+
+	resps := []finReq.FinReportPurseUsageListRes{}
+	response.Copy(&resps, objs)
+	for index, item := range resps {
+		purse, err := srv.srvPurse.Detail(item.PurseId, auth)
+		if err == nil && purse.Id > 0 {
+			item.PurseAmount = purse.ElectricAmount
+		}
+		resps[index] = item
+	}
+	return response.PageResp{
+		PageNo:   page.PageNo,
+		PageSize: page.PageSize,
+		Count:    count,
+		Lists:    resps,
+	}, nil
+}
+
+// ListStepBill 阶梯电价列表
+func (srv finReportService) ListStepBill(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error) {
+	// 分页信息
+	limit := page.PageSize
+	offset := page.PageSize * (page.PageNo - 1)
+	// 查询
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinPurseFlow{}), auth)
+	if listReq.AreaId != 0 {
+		model = model.Where("area_id = ?", listReq.AreaId)
+	}
+	if len(listReq.AreaName) > 0 {
+		model = model.Where("area_name like %?%", listReq.AreaName)
+	}
+	if listReq.HouseId != 0 {
+		model = model.Where("house_id = ?", listReq.HouseId)
+	}
+	if listReq.HouseName != "" {
+		model = model.Where("house_name like %?%", listReq.HouseName)
+	}
+	nilTime := time.Time{}
+	if listReq.StartDay != nilTime {
+		model = model.Where("ecs_time >= ?", listReq.StartDay)
+	}
+	if listReq.EndDay != nilTime {
+		model = model.Where("ecs_time <= ?", listReq.EndDay)
+	}
+	model = model.Where("bill_type = '0'")
+
+	// 总数
+	var count int64
+	err := model.Count(&count).Error
+	if e = response.CheckErr(err, "List Count err"); e != nil {
+		return
+	}
+	// 数据
+	var objs []finModel.FinBill
+	err = model.Limit(limit).Offset(offset).Order("id desc").Find(&objs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+
+	resps := []finReq.FinReportStepListRes{}
+	response.Copy(&resps, objs)
+	for index, item := range resps {
+		step := finReq.FinReportStepItemRes{
+			Id:     0,
+			Usage:  100,
+			Amount: 10.23,
+		}
+		item.Details = append(item.Details, step)
+		step1 := finReq.FinReportStepItemRes{
+			Id:     1,
+			Usage:  100,
+			Amount: 10.23,
+		}
+		item.Details = append(item.Details, step1)
+		step2 := finReq.FinReportStepItemRes{
+			Id:     2,
+			Usage:  100,
+			Amount: 10.23,
+		}
+		item.Details = append(item.Details, step2)
+		step3 := finReq.FinReportStepItemRes{
+			Id:     3,
+			Usage:  100,
+			Amount: 10.23,
+		}
+		item.Details = append(item.Details, step3)
+		resps[index] = item
+	}
+	return response.PageResp{
+		PageNo:   page.PageNo,
+		PageSize: page.PageSize,
+		Count:    count,
+		Lists:    resps,
+	}, nil
+}
+
+// ListPurseShared 公摊账单列表
+func (srv finReportService) ListPurseShared(page request.PageReq, listReq finReq.FinReportPurseReq, auth *request.AuthReq) (res response.PageResp, e error) {
+	// 分页信息
+	limit := page.PageSize
+	offset := page.PageSize * (page.PageNo - 1)
+	// 查询
+	model := query.NewAuthQuery(srv.db.Model(&finModel.FinPurseFlow{}), auth)
+	if listReq.AreaId != 0 {
+		model = model.Where("area_id = ?", listReq.AreaId)
+	}
+	if len(listReq.AreaName) > 0 {
+		model = model.Where("area_name like %?%", listReq.AreaName)
+	}
+	if listReq.HouseId != 0 {
+		model = model.Where("house_id = ?", listReq.HouseId)
+	}
+	if listReq.HouseName != "" {
+		model = model.Where("house_name like %?%", listReq.HouseName)
+	}
+	nilTime := time.Time{}
+	if listReq.StartDay != nilTime {
+		model = model.Where("payment_time >= ?", listReq.StartDay)
+	}
+	if listReq.EndDay != nilTime {
+		model = model.Where("payment_time <= ?", listReq.EndDay)
+	}
+
+	var finBill finModel.FinBill
+	billCond := "select id from " + finBill.TableName() + " where bill_type in('3','4','5','6')"
+	model = model.Where("bill_id in(" + billCond + ")")
+
+	// 总数
+	var count int64
+	err := model.Count(&count).Error
+	if e = response.CheckErr(err, "List Count err"); e != nil {
+		return
+	}
+	// 数据
+	var objs []finModel.FinPurseFlow
+	err = model.Limit(limit).Offset(offset).Order("id desc").Find(&objs).Error
+	if e = response.CheckErr(err, "List Find err"); e != nil {
+		return
+	}
+
+	resps := []finReq.FinReportSharedBillRes{}
+	response.Copy(&resps, objs)
+	for index, item := range resps {
+		bill, err := srv.srvBill.Detail(item.BillId, auth)
+		if err == nil && bill.Id > 0 {
+			item.AreaName = bill.AreaName
+			item.HouseName = bill.HouseName
+			item.DeviceName = bill.DeviceName
+			item.Address = bill.Address
+		}
+		resps[index] = item
+	}
+	return response.PageResp{
+		PageNo:   page.PageNo,
+		PageSize: page.PageSize,
+		Count:    count,
+		Lists:    resps,
+	}, nil
 }
